﻿using System.Collections.Generic;
using Ueberpruefung;

namespace Eingabeverwaltung.Metamodell
{
	public class Transformation : SingleProof
	{
		public readonly Tree                     startTree;
		public readonly List<TransformationStep> transformationSteps;
		public readonly List<Error>              errors;

		public Transformation(Coords coords, Tree startTree, List<TransformationStep> transformationSteps) : base(coords)
		{
			this.startTree           = startTree;
			this.transformationSteps = transformationSteps;
			errors = new List<Error>();
		}

		public override string ToString(bool showMetadata) => ToString();
        public override string ToString()
        {
            string res = "Transformation:\r\n";
            res += startTree.ToString() + "\r\n";
            foreach (TransformationStep ts in transformationSteps) res += ts.ToString(); 
            return res;
        }
    }
}
