﻿using Antlr4.Runtime;
using System.Collections.Generic;
using System.IO;

namespace Eingabeverwaltung.Parser
{
    class ErrorListener : IAntlrErrorListener<IToken>
    {
        public readonly List<KontextException> errors;

        public ErrorListener() => errors = new List<KontextException>();

        public void SyntaxError(TextWriter output, IRecognizer recognizer, IToken offendingSymbol, int line, int charPositionInLine, string msg, RecognitionException e)
            => errors.Add(new KontextException(new Coords(line, charPositionInLine), msg));

        public void throwErrors()
        {
            string errorMessage = "";
            foreach (var error in errors)
                errorMessage += error.Message+"\r\n";
            throw new System.Exception(errorMessage);
        }
    }
}
