﻿

using Eingabeverwaltung.Metamodell;
using Eingabeverwaltung.Parser;
using System.Collections.Generic;
using System.Collections.Immutable;
using System;
using System.IO;

namespace Eingabeverwaltung
{
    /// <summary>
    /// TestEingabeverwalter lets you managing the input and the exceptions thrown while parsing. 
    /// </summary>
    public class TestEingabeverwalter : AbstractEingabeverwalter
    {
        public TestEingabeverwalter() :base() { }

        /// <summary>
        /// All Tests are managing its input on their own, they need to call each input file on their own
        /// </summary>
        /// <exception cref="InvalidOperationException"></exception>
        public override void verwalteEingabe()
        {
            throw new InvalidOperationException();
        }

        /// <summary>
        /// This is only for Testing. All Exceptions
        /// </summary>
        /// <param name="action"></param>
        /// <param name="path"></param>
        public void Eingabe_Interface(string action, string path)
        {
            ImmutableDictionary<string, Action<string>> eingabe = new Dictionary<string, Action<string>>
            {
                ["ADT"] = ADT_Eingabe,
                ["Task"] = Task_Eingabe,
                ["Proof"] = Proof_Eingabe,
            }.ToImmutableDictionary();
            string input = File.ReadAllText(path);
            eingabe[action](input);
            void ADT_Eingabe(string input)
            {
                ADT adt = ADT_Antlr.parse(input);
                inputContainer = new Container();
                inputContainer.ADT = adt;
            }
            void Task_Eingabe(string input)
            {
                Task_Antlr.parse(input, inputContainer);
                inputContainer.Proof = null;
            }
            void Proof_Eingabe(string input)
            {
                Proof_Antlr.parse(input,inputContainer);
            }
        }
    }
}
