﻿using Eingabeverwaltung.Metamodell;
using System;

namespace Ueberpruefung.CheckTransformation
{
    public class CheckSubstitutionVariable_isUsedInRule : ElementChecker
    {
        public CheckSubstitutionVariable_isUsedInRule() { } 

        /// <summary>
        /// Requires: all variables in substitutions are not null, otherwise NullReferenceException will be thrown.
        /// </summary>
        /// <param name="ts"></param>
        /// <returns></returns>
        public override bool check(Element e)
        {
            if (e is TransformationStep ts)
            {
                bool result = true, res;
                foreach (Substitution sub in ts.substitutions)
                {
                    res = ts.rule.eq.leftTree.findSubTree(new TreeVariable(sub.variable)).Count > 0
                         || ts.rule.eq.rightTree.findSubTree(new TreeVariable(sub.variable)).Count > 0;
                    if (!res) sub.errors.Add(new Error(13));
                }
                return result;
            }
            else throw new InvalidOperationException();
        }
    }
}